#!/usr/bin/env python

import sys
import re
import string
from sss import ssslib
import xml.dom.minidom
import clusterdb

types = ["node","mayor","image","kernel","kernel_opts","action",
         "powerdev","powerport","consoledev","consoleport","switch",
         "switchport","hwaddr","iftype","state","adminstate","tag"]

def get_record_info(component):
    return {"build-system":"node-software",
            "cluster-hardware":"node-hardware",
            "node-state-manager":"node-state"}[component]

arg_re = re.compile("^(-[d] )*get (?P<function>(\w+,{0,1})+) -r (?P<restrictions>(\w+=\w+ {0,1})+)$")

match = arg_re.match(string.join(sys.argv[1:]," "))

if not match:
    print "Usage: cdb.py [-d] get field1,field2,field3 -r <restrictions>"
    print "\t\t-d\tDebugging - Enable SSSLib debugging"
    sys.exit(1)

function = match.group("function")
restrictions = match.group("restrictions")

restrictions = string.split(restrictions)
pair_restrictions = map(lambda x:string.split(x,"="),restrictions)

component_paths = []

if "get" in sys.argv[1:]:
    cdb = clusterdb.connect()
    cursor = cdb.cursor()

    cursor.execute("SELECT %s FROM clusterdb WHERE %s"%
                       (function,
                       string.join(restrictions)))

    print cursor.fetchall()

    sys.exit(0)

if "-n" in sys.argv:
    for out in output_list:
        print out
    sys.exit(0)
