#!/usr/bin/env python
from MySQLdb import connect
from xml.dom.minidom import Document
from string import split,join
from threading import Lock
from sss.server import SSSSelectServer, AddEvent, rquery

class chiba_build(SSSSelectServer):
    __implementation__='chiba-bs'
    __component__='build-system'

    def __parseinput__(self):
        #self.connection = connect(host="localhost",user="andrew",db="test")
        self.connection = connect(host="localhost",user="buildman",db="builddb",passwd="bm")
        self.cursor = self.connection.cursor()
        self.swdata=rquery('build-system',self.cursor,'node-software','node-software-set')
        self.swdata.SetAction('build',['node'],self.Build,[])
        self.tagdata=rquery('build-system',self.cursor,'tag','tags')
        self.userdata=rquery('build-system',self.cursor,'user','users')
        self.dispatch={'get-node-software':self.swdata.Get,
                       'add-node-software':self.swdata.Add,
                       'set-node-software':self.swdata.Set,
                       'del-node-software':self.swdata.Del,
                       'get-tag':self.tagdata.Get,
                       'set-tag':self.tagdata.Set,
                       'add-tag':self.tagdata.Add,
                       'del-tag':self.tagdata.Del,
                       'get-users':self.userdata.Get,
                       'set-users':self.userdata.Set,
                       'add-users':self.userdata.Add,
                       'del-users':self.userdata.Del,
                       'build-node':self.swdata.build}

    def Build(self,nodelist):
        pass

if __name__ == '__main__':
    from getopt import getopt, GetoptError
    from sys import argv,exit
    try:
        (opts,args)=getopt(argv[1:],'d',['daemon='])
    except GetoptError,msg:
        print "%s\nUsage:\nbs.py [-d] [--daemon <pidfile>]"%(msg)
        exit(1)
    daemon=[x[1] for x in opts if x[0] == '--daemon']
    debug=len([x for x in opts if x[0] == '-d'])
    if daemon:
        from sss.daemonize import daemonize
        daemonize(daemon[0])
    server=chiba_build(debug=debug)
    server.ServeForever()
